
#include "rbac.h"
#include "../language/error.h"
#include <stdlib.h>

struct user_s *rbac_users=NULL;

struct user_s * rbac_user_add( char *name, uid_t uid )
{ struct user_s *n,**p;
  int x=1;
	for(p=&rbac_users;(*p)!=NULL;p=&((*p)->next))
		if( (x=strcmp((*p)->name,name))>=0 )
			break;
	if( x==0 )
	{	errstr="Redefinition of user";
		return(NULL);
	}
	if( (n=malloc(sizeof(struct user_s)+strlen(name)+1))==NULL )
	{	errstr=Out_of_memory;
		return(NULL);
	}
//	vs_clear(n->vs);
	strcpy(n->name,name);
	n->uid=uid;
	n->ua=NULL;
	n->next=*p;
	*p=n;
	return(n);
}

struct user_s * rbac_user_find( char *name )
{ struct user_s *p;
	for(p=rbac_users;p!=NULL;p=p->next)
		if( strcmp(p->name,name)==0 )
			return(p);
	return(NULL);
}

struct user_s * rbac_user_find_by_uid( uid_t uid )
{ struct user_s *p;
	for(p=rbac_users;p!=NULL;p=p->next)
		if( p->uid==uid )
			return(p);
	return(NULL);
}

//int rbac_all_users_add_vs( const vs_t *vs )
//{ struct user_s *p;
//	for(p=rbac_users;p!=NULL;p=p->next)
//		vs_add(vs,p->vs);
//	return(0);
//}


