
#include "constable.h"
#include "object.h"
#include "subject.h"

static struct subject_get_s *sg_link=NULL;

int subject_register( int(*get)(vs_t *vs,int n,struct object_s *o) )
{ struct subject_get_s *p;
	if( (p=malloc(sizeof(struct subject_get_s)))==NULL )
		return(-1);
	p->get=get;
	p->next=sg_link;
	sg_link=p;
	return(0);
}

int subject_get_vs( vs_t *vs, int n, struct object_s *o )
{ struct subject_get_s *p;
	vs_clear(vs);
	if( n<0 || n>=NR_ACCESS_TYPES )
		return(-1);
	for(p=sg_link;p!=NULL;p=p->next)
		p->get(vs,n,o);
	return(0);
}


