
#include "../constable.h"
#include "../event.h"

struct event_type_s *get_event_context( struct event_context_s *c, void *data )
{ struct event_type_s *t;
  	if( (t=event_type_find( ((u_int16_t*)data)[0], ((u_int16_t*)data)[1] ))
		==NULL )
	{	c->result=RESULT_UNKNOWN;
		return(NULL);
	}
	c->operation.next=&(c->subject);
	c->operation.attr.offset=c->operation.attr.length=0;
	c->operation.attr.type=MED_TYPE_END;
	strncpy(c->operation.attr.name,t->m.name,MIN(MEDUSA_ATTRNAME_MAX,MEDUSA_OPNAME_MAX));
	c->operation.class=&(t->operation_class);
	c->operation.data=(char*)(data)+2*sizeof(u_int16_t);

	c->subject.next=&(c->object);
	c->subject.attr.offset=c->subject.attr.length=0;
	c->subject.attr.type=MED_TYPE_END;
	strncpy(c->subject.attr.name,t->m.op_name[0],MEDUSA_ATTRNAME_MAX);
	c->subject.class=t->op[0];
	c->subject.data=(char*)(data)+2*sizeof(u_int16_t)+(t->m.size);
	c->object.next=NULL;
	c->object.attr.offset=c->object.attr.length=0;
	c->object.attr.type=MED_TYPE_END;
	strncpy(c->object.attr.name,t->m.op_name[1],MEDUSA_ATTRNAME_MAX);
	c->object.class=t->op[1];
	c->object.data=(char*)(data)+2*sizeof(u_int16_t)+(t->m.size);
	if( c->subject.class!=NULL )
		c->object.data+= c->subject.class.m.size;
	return(t);
}

int put_event_context( struct event_context_s *c, void *data )
{

	return(-1);
}
