
#include <stdio.h>
#include <stdarg.h>
#include <unistd.h>
#include "constable.h"

int init_error( const char *fmt, ... )
{ va_list ap;
  char buf[4096];

	va_start(ap,fmt);
	vsnprintf(buf, 4000, fmt, ap);
	va_end(ap);
	sprintf(buf+strlen(buf),"\n");
	write(1,buf,strlen(buf));
	return(-1);
}

int runtime( const char *fmt, ... )
{ va_list ap;
  char buf[4096];

	sprintf(buf,"Runtime error : ");

	va_start(ap,fmt);
	vsnprintf(buf+strlen(buf), 4000, fmt, ap);
	va_end(ap);
	medusa_printlog("%s",buf);
	sprintf(buf+strlen(buf),"\n");
	write(1,buf,strlen(buf));
	return(0);
}

int fatal( const char *fmt, ... )
{ va_list ap;
  char buf[4096];

	sprintf(buf,"Fatal error : ");

	va_start(ap,fmt);
	vsnprintf(buf+strlen(buf), 4000, fmt, ap);
	va_end(ap);
	medusa_printlog("%s",buf);
	sprintf(buf+strlen(buf),"\n");
	write(1,buf,strlen(buf));
	exit(-1);
	return(0);
}


