
#include "variables.h"
#include "../constable.h"

struct object_s *alloc_var( char *name, struct medusa_attribute_s *attr, struct class_s * class )
{ struct object_s *v;
  int l;
	if( !attr == !class )
		return(NULL);
	if( class==NULL )
		l=attr->length;
	else	l=class->m.size;
	if( (v=malloc(sizeof(struct object_s)+l))==NULL )
		return(NULL);
	v->next=NULL;
	if( class==NULL )
	{	v->attr = *attr;
		v->attr.offset=0;
		v->class=NULL;
		v->data= (char*)(v+1);
	}
	else
	{	v->attr.offset=0;
		v->attr.length=class->m.size;
		v->attr.type=MED_TYPE_END;
		v->class=class;
		v->data= (char*)(v+1);
	}
	strncpy(v->attr.name,name,MEDUSA_ATTRNAME_MAX);
	return(v);
}

struct object_s *var_link( struct object_s **v, struct object_s *var )
{ int r=1;
	for(;(*v)!=NULL;v=&((*v)->next))
		if( (r=strncmp((*v)->attr.name,var->attr.name,MEDUSA_ATTRNAME_MAX))>=0 )
			break;
	if( r==0 )
		return(NULL);
	var->next=*v;
	*v=var;
	return(var);
}

struct object_s *get_var( struct object_s *v, char *name )
{ int r;
	for(;v!=NULL;v=v->next)
		if( (r=strncmp(v->attr.name,name,MEDUSA_ATTRNAME_MAX))>=0 )
		{	if( r==0 )
				return(v);
			else	return(NULL);
		}
	return(NULL);
}

int var_to_sval( struct object_s *v, char *atr, struct sval_s *s )
{ struct medusa_attribute_s *a;
	if( atr==NULL )
	{	s->type=(u_int32_t)(&(v->attr));
//		if( v->class==NULL )
			s->data=(u_int32_t)(v->data);
//		else	s->data=0;
		return(0);
	}
	if( (a=get_attribute(v->class,atr))==NULL )
		return(-1);
	s->type=(u_int32_t)(a);
	s->data=((u_int32_t)(v->data));
	return(0);
}

